﻿using System;
using System.Configuration;
using System.Net;
using ITHit.WebDAV.Logger;

namespace WebDAVServer.Class1Listener
{
    class Program
    {
        static void Main(string[] args)
        {
            string uriPrefix = ConfigurationManager.AppSettings["ListenerPrefix"];
            HttpListener listener = new HttpListener();
            listener.Prefixes.Add(uriPrefix);
            listener.Start();

            Console.WriteLine("Start listening on " + uriPrefix);
            Console.WriteLine("Press Control-C to stop listener...");

            FileLogger.Level = LogLevel.Debug;

            while (true)
            {
                
                HttpListenerContext context = listener.GetContext();
                WDEngine engine = new WDEngine();
                engine.Run(context, listener.Prefixes);
                try
                {
                    context.Response.Close();
                }
                catch
                {
                    // client closed connection before the content was sent
                }
            }
        }
    }
}
