using System.IO;
using System.Web;
using ITHit.WebDAV.Logger;
using ITHit.WebDAV.Server;

namespace WebDAVServer.SqlStorage
{
    /// <summary>
    /// This handler processes requests to folders returning custom HTML page.
    /// </summary>
    class MyCustomGetHandler : IMethodHandler
    {
        private IMethodHandler originalHandler;

        public IMethodHandler OriginalHandler
        {
            set { originalHandler = value; }
        }

        #region IMethodHandler Members

        public void ProcessRequest(Request request, IResponse response, IHierarchyItem item)
        {
            if (item is IFolder)
            {
                using (TextReader reader = File.OpenText(HttpContext.Current.Request.PhysicalApplicationPath + "MyCustomHandlerPage.html"))
                {
                    string html = reader.ReadToEnd();
                    html = html.Replace("_webDavServerRoot_", request.ApplicationPath);
                    using (StreamWriter writer = new StreamWriter(response.OutputStream))
                    {
                        writer.Write(html);
                    }
                    FileLogger.WriteMessage(html, LogLevel.Debug);
                }
            }
            else
                originalHandler.ProcessRequest(request, response, item);
        }

        #endregion // IMethodHandler Members
    }
}
